#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Basis1"
#define MYWNDCLASS		"CLASS_DX9_Basis1"
#define WIDTH			320 			// ʂ̉̃TCY
#define HEIGHT			240 			// ʂ̏c̃TCY

struct LVERTEX			// _tH[}bg̒`
{
	D3DXVECTOR3	v;		// _W
	D3DCOLOR	c;		// _F
};
#define FVF_LVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE)

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;

// ݒ
HRESULT Initialize(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
//	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev );
	
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// Cg
	g_pD3DDev->LightEnable(0, false);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, false);
	// _tH[}bg̐ݒ
	g_pD3DDev->SetFVF(FVF_LVERTEX);
	
	// r[s̐ݒ
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0,-2.5f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVs̐ݒ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	
	return S_OK;
}// Initialize

// I
void Cleanup()
{
	// Direct3D IuWFNg
	if(g_pD3DDev){
		g_pD3DDev->Release();
		g_pD3DDev = NULL;
	}
	if(g_pD3D){
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}// Cleanup

// `
void Draw()
{
	LVERTEX lv[3];
	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	g_pD3DDev->BeginScene();
	lv[0].v.x = -0.5f;
	lv[0].v.y = 0.5f;
	lv[0].v.z = 0;
	lv[0].c = D3DCOLOR_ARGB(255,255,0,0);
	lv[1].v.x = 0.5f;
	lv[1].v.y = 0.5f;
	lv[1].v.z = 0;
	lv[1].c = D3DCOLOR_ARGB(255,0,255,0);
	lv[2].v.x = 0;
	lv[2].v.y = -0.5f;
	lv[2].v.z = 0;
	lv[2].c = D3DCOLOR_ARGB(255,0,0,255);
	g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,1,lv,sizeof(LVERTEX));
	g_pD3DDev->EndScene();
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
}// Draw

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		Initialize(hWnd);			// ݒ
		break;
		
	case WM_PAINT:
		Draw();						// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 			// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		DestroyWindow(hWnd);
		Cleanup();					// I
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
