#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Basis4"
#define MYWNDCLASS		"CLASS_DX9_Basis4"
#define WIDTH			320 			// ʂ̉̃TCY
#define HEIGHT			240 			// ʂ̏c̃TCY

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMeshTea = NULL;	// XbV

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3	vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	light.Specular = light.Diffuse;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.5f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00909090);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARENABLE, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
}// Set_Light

// }eAݒ
void Set_Material()
{
	D3DMATERIAL9	mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = 1.0f;
	mtrl.Diffuse.r = 0.0;
	mtrl.Diffuse.g = 0.0;
	mtrl.Diffuse.b = 1.0;
	mtrl.Ambient = mtrl.Diffuse;
	mtrl.Specular.a = 1.0f;
	mtrl.Specular.r = 1.0f;
	mtrl.Specular.g = 1.0f;
	mtrl.Specular.b = 1.0f;
	mtrl.Power = 50;
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material

// ݒ
HRESULT Initialize(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
//	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev );
	
	// JO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	
	// r[s̐ݒ
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0,-5.0f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVs̐ݒ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	
	// Ɩݒ
	Set_Light();
	// }eAݒ
	Set_Material();
	// eB[|bg̍쐬
	D3DXCreateTeapot(g_pD3DDev, &g_pMeshTea, NULL);
	
	return S_OK;
}// Initialize

// I
void Cleanup()
{
	// XbV
	if(g_pMeshTea){
		g_pMeshTea->Release();
		g_pMeshTea = NULL;
	}
	// Direct3D IuWFNg
	if(g_pD3DDev){
		g_pD3DDev->Release();
		g_pD3DDev = NULL;
	}
	if(g_pD3D){
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}// Cleanup

// `
void Draw()
{
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	g_pD3DDev->BeginScene();
	// [hs̐ݒ
	static int roll = 0;
	D3DXMATRIX matWorld;
	D3DXMatrixRotationY(&matWorld,(float)roll/180*D3DX_PI);
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);
	roll += 5;
	if(roll >= 360){
		roll = 0;
	}
	// eB[|bg̕`
	g_pMeshTea->DrawSubset(0);
	g_pD3DDev->EndScene();
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
}// Draw

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		Initialize(hWnd);			// ݒ
		SetTimer(hWnd,1,100,NULL);	// ^C}[ݒ
		break;
		
	case WM_TIMER:
		Draw();						// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 			// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();					// I
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
