#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Basis6"
#define MYWNDCLASS		"CLASS_DX9_Basis6"
#define WIDTH			320 			// ʂ̉̃TCY
#define HEIGHT			240 			// ʂ̏c̃TCY

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMesh = NULL;	// bV
LPDIRECT3DTEXTURE9		g_pTex = NULL;	// eNX`[

// bV쐬
void Create_CubeMesh()
{
	const int	v_num =	8;	// _
	const int	f_num =	12;	// ʐ
	// _W
	D3DXVECTOR3	vtx[v_num] =	{D3DXVECTOR3(0.5f,0.5f,-0.5f),D3DXVECTOR3(0.5f,0.5f,0.5f),
								D3DXVECTOR3(-0.5f,0.5f,0.5f),D3DXVECTOR3(-0.5f,0.5f,-0.5f),
								D3DXVECTOR3(0.5f,-0.5f,-0.5f),D3DXVECTOR3(0.5f,-0.5f,0.5f),
								D3DXVECTOR3(-0.5f,-0.5f,0.5f),D3DXVECTOR3(-0.5f,-0.5f,-0.5f)};
	// eNX`W
	D3DXVECTOR2	tex[v_num] =	{D3DXVECTOR2(1,0),D3DXVECTOR2(1,0),D3DXVECTOR2(0,0),D3DXVECTOR2(0,0),
								D3DXVECTOR2(1,1),D3DXVECTOR2(1,1),D3DXVECTOR2(0,1),D3DXVECTOR2(0,1)};
	// eʂ\钸_ԍ
	int		face[f_num][3] =	{{3,2,1},{3,1,0},{0,1,5},{0,5,4},{1,2,6},{1,6,5},
								{2,3,7},{2,7,6},{3,0,4},{3,4,7},{4,5,6},{4,6,7}};
	// 錾q
	const D3DVERTEXELEMENT9 decl[] =
	{
		{0,  0, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_POSITION, 0},
		{0, 12, D3DDECLTYPE_FLOAT3, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_NORMAL,	  0},
		{0, 24, D3DDECLTYPE_FLOAT2, D3DDECLMETHOD_DEFAULT, D3DDECLUSAGE_TEXCOORD, 0},
		D3DDECL_END()
	};
	BYTE	*pBuf1 = NULL;
	WORD	*pBuf2 = NULL;
	DWORD	*pBuf3 = NULL;
	DWORD	dwFVF1 = D3DFVF_XYZ | D3DFVF_TEX1;
	int		i;
	
	// bVIuWFNg쐬
	D3DXCreateMeshFVF(f_num, v_num, D3DXMESH_MANAGED, dwFVF1, g_pD3DDev, &g_pMesh);
	// _ݒ
	g_pMesh->LockVertexBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, (LPVOID*)&pBuf1);
	for(i=0; i<v_num; i++){
		memcpy(pBuf1, &vtx[i], sizeof(D3DXVECTOR3));
		pBuf1 += sizeof(D3DXVECTOR3);
		if(dwFVF1 & D3DFVF_TEX1){
			memcpy(pBuf1, &tex[i], sizeof(D3DXVECTOR2));
			pBuf1 += sizeof(D3DXVECTOR2);
		}
	}
	g_pMesh->UnlockVertexBuffer();
	// ʂ\Wԍ̐ݒ
	g_pMesh->LockIndexBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, (LPVOID*)&pBuf2);
	for(i=0; i<f_num; i++){
		*pBuf2 ++ = face[i][0];
		*pBuf2 ++ = face[i][1];
		*pBuf2 ++ = face[i][2];
	}
	g_pMesh->UnlockIndexBuffer();
	// obt@ݒ
	g_pMesh->LockAttributeBuffer(D3DLOCK_DISCARD | D3DLOCK_DONOTWAIT, &pBuf3);
	for(i=0; i<f_num; i++){
		*pBuf3 ++ = 0;
	}
	g_pMesh->UnlockAttributeBuffer();
	// e[uݒ
	D3DXATTRIBUTERANGE attr;
	attr.AttribId	 = 0;
	attr.FaceStart	 = 0;
	attr.FaceCount	 = f_num;
	attr.VertexStart = 0;
	attr.VertexCount = v_num;
	g_pMesh->SetAttributeTable(&attr, 1);
	// _@ǉ
	LPD3DXMESH pTempMesh = NULL;
	g_pMesh->CloneMesh(NULL, decl, g_pD3DDev, &pTempMesh);
	g_pMesh->Release();
	g_pMesh = NULL;
	if(pTempMesh)  g_pMesh = pTempMesh;
	D3DXComputeNormals(g_pMesh, NULL);
	// bVœKi`摬xj
	g_pMesh->OptimizeInplace(
						D3DXMESHOPT_COMPACT | D3DXMESHOPT_ATTRSORT | D3DXMESHOPT_IGNOREVERTS |
						D3DXMESHOPT_VERTEXCACHE | D3DXMESHOPT_DEVICEINDEPENDENT,
						NULL, NULL, NULL, NULL );
}// Create_CubeMesh

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3	vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = 1.0f;
	light.Diffuse.g = 1.0f;
	light.Diffuse.b = 1.0f;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.5f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00909090);
}// Set_Light

// }eAݒ
void Set_Material()
{
	D3DMATERIAL9	mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = 1.0f;
	mtrl.Diffuse.r = 1.0;
	mtrl.Diffuse.g = 1.0;
	mtrl.Diffuse.b = 1.0;
	mtrl.Ambient = mtrl.Diffuse;
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material

// ݒ
HRESULT Initialize(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
//	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev );
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// r[sݒ
	D3DXMATRIX matView;
	D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(0,0,-2.5f),&D3DXVECTOR3(0,0,0),&D3DXVECTOR3(0,1,0));
	g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
	// vWFNVsݒ
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,D3DX_PI/4,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	// bV쐬
	Create_CubeMesh();
	// Jg fBNg[st@C̃fBNg[ɐݒ
	char path[MAX_PATH];
	GetModuleFileName(NULL,path,sizeof(path));
	char *p = strrchr(path, '\\');
	if(p){
		strcpy(p, "");
		SetCurrentDirectory(path);
	}
	// eNX`[ݒ
	D3DXCreateTextureFromFile(g_pD3DDev, "tex1.png", &g_pTex);
	// Ɩݒ
	Set_Light();
	// }eAݒ
	Set_Material();
	
	return S_OK;
}// Initialize

// I
void Cleanup()
{
	// bV
	if(g_pMesh){
		g_pMesh->Release();
		g_pMesh = NULL;
	}
	// eNX`[
	if(g_pTex){
		g_pTex->Release();
		g_pTex = NULL;
	}
	// Direct3D IuWFNg
	if(g_pD3DDev){
		g_pD3DDev->Release();
		g_pD3DDev = NULL;
	}
	if(g_pD3D){
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}// Cleanup

// `
void Draw()
{
	// ʃNA
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	// `Jn
	g_pD3DDev->BeginScene();
	// eNX`[Kp
	if(g_pTex)
		g_pD3DDev->SetTexture(0, g_pTex);
	// bV`
	if(g_pMesh)
		g_pMesh->DrawSubset(0);
	// Y]
	static float roll = 0;
	D3DXMATRIX	matRY;
	D3DXMatrixRotationY(&matRY, roll/180*D3DX_PI);
	g_pD3DDev->SetTransform(D3DTS_WORLD, &matRY);
	roll += 1;
	if(roll >= 360)
		roll = 0;
	// `I
	g_pD3DDev->EndScene();
	// eNX`[
	g_pD3DDev->SetTexture(0, NULL);
	// ʃtbv
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
}// Draw

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		Initialize(hWnd);	// ݒ
		break;
		
	case WM_PAINT:
		Draw();				// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 	// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		DestroyWindow(hWnd);
		Cleanup();			// I
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
