#include <d3dx9.h>

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")

#define MYWNDTITLE		"DX9_Basis7"
#define MYWNDCLASS		"CLASS_DX9_Basis7"
#define WIDTH			320 	// ʂ̉̃TCY
#define HEIGHT			240 	// ʂ̏c̃TCY

const char g_szEffect[] = 
"struct VS_IN"
"{"
	"float4 Pos    : POSITION;"	// _W
	"float3 Normal : NORMAL;"	// _@xNg
"};"

"struct VS_OUT"
"{"
	"float4 Pos    : POSITION;"	// _W
	"float4 Color  : COLOR;"	// _F
"};"

"float4x4 matWorld;"	// [hs
"float4x4 matAll;"		// ϊs
"float3   v3Light;"		// Ɩ̌

// _VF[_֐
"VS_OUT VS(VS_IN In)"
"{"
	"VS_OUT Out;"
	"float3 Normal;"
	// _@[hϊ
	"Normal    = normalize(mul(In.Normal, matWorld));"
	// _W𓧎ϊ
	"Out.Pos   = mul(In.Pos, matAll);"
	// Lambert ƖfŒ_FZo
	"Out.Color = saturate(dot(Normal, v3Light));"
	"return Out;"
"}"

"technique T0"
"{"
	"pass P0"
	"{"
		// ֐RpCĒ_VF[_ɓn
		"VertexShader = compile vs_2_0 VS();"
	"}"
"}";

LPDIRECT3D9 			g_pD3D = NULL;
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;
D3DPRESENT_PARAMETERS	g_d3dpp;
LPD3DXMESH				g_pMeshTea = NULL;		// XbVIuWFNg
LPD3DXEFFECT			g_pEffect = NULL;		// GtFNgIuWFNg
D3DXVECTOR3				g_posLook(0,0,-5.0f);	// _
D3DXVECTOR3				g_posLookAt(0,0,0);		// _
D3DXMATRIX				g_matProj,g_matView;

// ݒ
HRESULT Initialize(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	
	ZeroMemory( &g_d3dpp, sizeof(g_d3dpp) );
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
//	g_d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	
	// D3D9Device 쐬
	g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
						  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
						  &g_d3dpp, &g_pD3DDev );
	
	// JOݒ
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	// Zobt@L
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE, TRUE);
	// r[s쐬
	D3DXMatrixLookAtLH(&g_matView, &g_posLook, &g_posLookAt, &D3DXVECTOR3(0,1,0));
	// vWFNVs쐬
	D3DXMatrixPerspectiveFovLH(&g_matProj, D3DX_PI/4, (float)WIDTH/HEIGHT, 0.01f, 10.0f);
	// eB[|bg쐬
	D3DXCreateTeapot(g_pD3DDev, &g_pMeshTea, NULL);
	// GtFNgǂݍ
	D3DXCreateEffect(g_pD3DDev, g_szEffect, strlen(g_szEffect),
					NULL, NULL, 0, NULL, &g_pEffect, NULL);
	// eNjbNI
	if(g_pEffect){
		g_pEffect->SetTechnique("T0");
	}
	return S_OK;
}// Initialize

// I
void Cleanup()
{
	// XbV
	if(g_pMeshTea){
		g_pMeshTea->Release();
		g_pMeshTea = NULL;
	}
	// GtFNg
	if(g_pEffect){
		g_pEffect->Release();
		g_pEffect = NULL;
	}
	// Direct3D IuWFNg
	if(g_pD3DDev){
		g_pD3DDev->Release();
		g_pD3DDev = NULL;
	}
	if(g_pD3D){
		g_pD3D->Release();
		g_pD3D = NULL;
	}
}// Cleanup

// `
void Draw()
{
	if(!g_pEffect){
		return;
	}
	g_pD3DDev->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(0,0,0), 1.0f, 0);
	g_pD3DDev->BeginScene();
	// [hϊs쐬
	static int roll = 0;
	D3DXMATRIX matWorld;
	D3DXMatrixRotationY(&matWorld, (float)roll/180*D3DX_PI);
	// [hϊs𒸓_VF[_ɑM
	g_pEffect->SetMatrix("matWorld", &matWorld);
	// ϊs𒸓_VF[_ɑM
	g_pEffect->SetMatrix("matAll", &(matWorld * g_matView * g_matProj));
	// Ɩ̕𒸓_VF[_ɑM
	g_pEffect->SetVector("v3Light", &D3DXVECTOR4(-0.866025f,0.5f,-0.5f,0.0f));
	// ]pxXV
	roll += 5;
	if(roll >= 360){
		roll = 0;
	}
	// eB[|bg̕`
	UINT iPassCount;
	g_pEffect->Begin(&iPassCount, 0);
	g_pEffect->Pass(0);
	g_pMeshTea->DrawSubset(0);
	g_pEffect->End();
	// `I
	g_pD3DDev->EndScene();
	// ʃtbv
	g_pD3DDev->Present(NULL, NULL, NULL, NULL);
}// Draw

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		Initialize(hWnd);			// ݒ
		SetTimer(hWnd,1,100,NULL);	// ^C}[ݒ
		break;
		
	case WM_TIMER:
		Draw();						// IuWFNg̕`
		break;
		
	case WM_KEYDOWN:
		switch ( wParam )
		{
		case VK_ESCAPE: 			// [ESC] L[ƏI
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();					// I
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpCmdLine,int nCmdShow)
{
	WNDCLASSEX	wc;
	HWND		hWnd;

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;

	hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);
	
	MSG msg; 
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain
